using System;
using System.Collections;

using System.Reflection;
using System.Runtime.CompilerServices;

[assembly:AssemblyVersion("1.0.0.0")]

namespace MyBankSoftware {
	public class BankServer {
		internal protected Hashtable objAccounts;
				
		public BankServer(){
			objAccounts = new Hashtable();
		}
		
		public void createAccount(string strAccountNum){
			if (strAccountNum == null){
				throw new BankOperationException(strAccountNum, "BankServer.createAccount()", "strAccountNum is null!");
			} else if (objAccounts.Contains(strAccountNum)){
				throw new BankOperationException(strAccountNum, "BankServer.createAccount()", "strAccountNum exists!");
			} else {
				Account ac = new Account(strAccountNum);
				objAccounts.Add(strAccountNum, ac);
			}
		}
		
		public void deleteAccount(string strAccountNum){
			Account ac = getAccount(strAccountNum);
			if (ac.AccountBalance!=0){
				throw new BankOperationException(strAccountNum, "BankServer.deleteAccount()", "AccountBalance not 0!");
			} else {
				objAccounts.Remove(strAccountNum);
			}
		}
		
		public void payoutAccount(string strAccountNum, double dblMoney){
			Account ac = getAccount(strAccountNum);
			ac.takeMoney(dblMoney);
		}
		
		public void payinAccount(string strAccountNum, double dblMoney){
			Account ac = getAccount(strAccountNum);
			ac.putMoney(dblMoney);
		}
		
		public double checkAccountBalance(string strAccountNum){
			Account ac = getAccount(strAccountNum);
			return ac.AccountBalance;
		}
		
		private Account getAccount(string strAccountNum){
			if (strAccountNum == null){
				throw new BankOperationException(strAccountNum, "BankServer.getAccount()", "strAccountNum is null!");
			} else if (!objAccounts.Contains(strAccountNum)){
				throw new BankOperationException(strAccountNum, "BankServer.getAccount()", "strAccountNum does not exist!");
			} else {
				return (Account)objAccounts[strAccountNum];
			}
		}
	}
	
}