using System;
using MyBankSoftware;

using System.Reflection;
using System.Runtime.CompilerServices;

[assembly:AssemblyVersion("1.0.0.0")]

namespace MyBankClientSoftware {
	public class BankClient{
		public static void Main(){
			BankServer objBank = new BankServer();
			
			string strCommand = null;
			string[] strCommands;
			
			do {
				try {
					Console.WriteLine("\n**** Bank Client Menu **** ");
					Console.WriteLine("1. (c)reate account: c <AccountNum>");
					Console.WriteLine("2. (d)elete account: d <AccountNum>");
					Console.WriteLine("3. check account (b)alance: b <AccountNum>");
					Console.WriteLine("4. pay (o)ut: o <AccountNum> <Amount>");
					Console.WriteLine("5. pay (i)n: i <AccountNum> <Amount>");
					Console.WriteLine("6. (q)uit \n");
					Console.Write("Please enter command: ");
					strCommand = (Console.ReadLine()).Trim();
					
					if (strCommand=="q" || strCommand=="Q"){
						break;
					}
					
					strCommands = strCommand.Split();
					strCommands[0] = strCommands[0].ToUpper();
					
					switch (strCommands[0]){
						case "C":
							if (strCommands.GetUpperBound(0) >= 1) {
								objBank.createAccount(strCommands[1]);
								Console.WriteLine("Account " + strCommands[1] + " created.");
							}
							break;
						case "D":
							if (strCommands.GetUpperBound(0) >= 1) {
								objBank.deleteAccount(strCommands[1]);
								Console.WriteLine("Account " + strCommands[1] + " deleted.");
							}
							break;
						case "B":
							if (strCommands.GetUpperBound(0) >= 1) {
								double d = objBank.checkAccountBalance(strCommands[1]);
								Console.WriteLine("Account " + strCommands[1] + " balance: " + d);
							}
							break;
						case "O":
							if (strCommands.GetUpperBound(0) >= 2) {
								double d = Convert.ToDouble(strCommands[2]);
								objBank.payoutAccount(strCommands[1], d);
								Console.WriteLine("From account " + strCommands[1] + " sum " + d + " paid out.");
							}
							break;
						case "I":
							if (strCommands.GetUpperBound(0) >= 2) {
								double d = Convert.ToDouble(strCommands[2]);
								objBank.payinAccount(strCommands[1], d);
								Console.WriteLine("Into account " + strCommands[1] + " sum " + d + " paid in.");
							}
							break;
						default:
							Console.WriteLine("Unknown command!");
							break;
					}
				} catch (BankOperationException e){
					Console.WriteLine("*** Bank Operation Error ***");
					Console.WriteLine("AccountNum: " + e.AccountNum);
					Console.WriteLine("Operation: " + e.Operation);
					Console.WriteLine("Message: " + e.Message);
					Console.WriteLine("");
				} catch (Exception e){
					Console.WriteLine("*** Program Error ***");
					Console.WriteLine("Message: " + e.Message);
					Console.WriteLine("StackTrace: " + e.StackTrace);
					Console.WriteLine("");
				}
			} while (true);
			Console.WriteLine("Quit.");
		}
	}
}