using System;
using System.Reflection;
using System.IO;

using MyBankSoftware;

namespace MyBankClientSoftware {
	public class BankClient{
		public static void Main(){
			BankServer objBank = new BankServer();
			
			string strCommand = null;
			string[] strCommands;
			
			Assembly a = Assembly.GetExecutingAssembly();
			Stream strm = a.GetManifestResourceStream ("Menu.txt");
			StreamReader sr = new StreamReader(strm);
			string strMenu = sr.ReadToEnd();
			sr.Close();
			
			do {
				try {
					Console.WriteLine(strMenu);
								
					Console.Write("Please enter command: ");
					strCommand = (Console.ReadLine()).Trim();
					
					if (strCommand=="q" || strCommand=="Q"){
						break;
					}
					
					strCommands = strCommand.Split();
					strCommands[0] = strCommands[0].ToUpper();
					
					switch (strCommands[0]){
						case "C":
							if (strCommands.GetUpperBound(0) >= 1) {
								objBank.createAccount(strCommands[1]);
								Console.WriteLine("Account " + strCommands[1] + " created.");
							}
							break;
						case "D":
							if (strCommands.GetUpperBound(0) >= 1) {
								objBank.deleteAccount(strCommands[1]);
								Console.WriteLine("Account " + strCommands[1] + " deleted.");
							}
							break;
						case "B":
							if (strCommands.GetUpperBound(0) >= 1) {
								double d = objBank.checkAccountBalance(strCommands[1]);
								Console.WriteLine("Account " + strCommands[1] + " balance: " + d);
							}
							break;
						case "O":
							if (strCommands.GetUpperBound(0) >= 2) {
								double d = Convert.ToDouble(strCommands[2]);
								objBank.payoutAccount(strCommands[1], d);
								Console.WriteLine("From account " + strCommands[1] + " sum " + d + " paid out.");
							}
							break;
						case "I":
							if (strCommands.GetUpperBound(0) >= 2) {
								double d = Convert.ToDouble(strCommands[2]);
								objBank.payinAccount(strCommands[1], d);
								Console.WriteLine("Into account " + strCommands[1] + " sum " + d + " paid in.");
							}
							break;
						default:
							Console.WriteLine("Unknown command!");
							break;
					}
				} catch (BankOperationException e){
					Console.WriteLine("*** Bank Operation Error ***");
					Console.WriteLine("AccountNum: " + e.AccountNum);
					Console.WriteLine("Operation: " + e.Operation);
					Console.WriteLine("Message: " + e.Message);
					Console.WriteLine("");
				} catch (Exception e){
					Console.WriteLine("*** Program Error ***");
					Console.WriteLine("Message: " + e.Message);
					Console.WriteLine("StackTrace: " + e.StackTrace);
					Console.WriteLine("");
				}
			} while (true);
			Console.WriteLine("Quit.");
		}
	}
}