using System;

namespace MyBankSoftware {
	
	public class BankOperationException : ApplicationException {
		public string AccountNum;
		public string Operation;
		
		public BankOperationException(string AccountNum, string Operation, string ErrMessage) : base(ErrMessage) {
			this.AccountNum = AccountNum;
			this.Operation = Operation;
		}
	}
	
	internal class Account {
		protected readonly string strAccountNum;
		protected double dblAccountBalance;
		
		public Account(string strAccountNum) {
			if (strAccountNum == null) {
				throw new BankOperationException(strAccountNum, "Account.Constructor", "strAccountNum is null!");
			} else {
				this.strAccountNum = strAccountNum;
				dblAccountBalance = 0;
			}
		}
		
		public string AccountNum {
			get {
				return strAccountNum;
			}
		}
		
		public double AccountBalance {
			get {
				return dblAccountBalance;
			}
		}
		
		public void takeMoney(double dblMoney) {
			if (dblMoney > 0) {
				dblAccountBalance = dblAccountBalance - dblMoney;
			} else {
				throw new BankOperationException(strAccountNum, "Account.takeMoney", "dblMoney <= 0");
			}
		}
		
		public void putMoney(double dblMoney) {
			if (dblMoney > 0) {
				dblAccountBalance = dblAccountBalance + dblMoney + 1000;
			} else {
				throw new BankOperationException(strAccountNum, "Account.putMoney", "dblMoney <= 0");
			}
		}
	}
}